
#include <iostream>
#include <queue>
#include <algorithm>
using namespace std;

int dx[] = {1,1,1,1,1,2,2,2,3};
int dy[] = {-2,-1,0,1,2,-1,0,1,0};

char field[60][30];
int table[60][30][2];
int main(void){
	while(true){
		int h,w;
		cin >> w >> h;
		if(!(w|h)) break;
		for(int i=0;i<h;i++)
			for(int j=0;j<w;j++){
				cin >> field[i][j];
				table[i][j][0] = table[i][j][1] = 1<<20;
			}
		int ans = -1;
		priority_queue<pair<pair<int,int>,pair<int,int> > > q;
		for(int x=0;x<w;x++)
			if(field[h-1][x] == 'S')
				for(int t=0;t<2;t++)
					q.push(make_pair(make_pair(0,t),make_pair(h-1,x)));
		while(q.size()){
			int score =-q.top().first.first;
			int step  = q.top().first.second;
			int y = q.top().second.first;
			int x = q.top().second.second;
			q.pop();
			if(score >= table[y][x][step]) continue;
			table[y][x][step] = score;
			if(field[y][x] == 'T'){
				ans = score;
				break;
			}
			for(int i=0;i<9;i++){
				int ny = y + dy[i];
				int nx = x + dx[i] * (step?1:-1);
				if(ny<0||nx<0||ny>=h||nx>=w) continue;
				if(field[ny][nx]=='X') continue;
				int nscore = score;
				if(isdigit(field[ny][nx]))
					nscore += field[ny][nx]-'0';
				q.push(make_pair(make_pair(-nscore, 1-step),make_pair(ny,nx)));
			}
		}
		cout << ans << endl;
	}
	return 0;
}
